
public class Class378_Sub2 extends Class378 {

   int anInt8980;
   byte[] aByteArray8981;
   int anInt8982;
   int anInt8983;
   int anInt8984;
   int anInt8985;
   int anInt8986;
   int anInt8987;
   int anInt8988;


   void method6569() {
      this.anInt8980 = 0;
      this.anInt8985 = 0;
   }

   void method14389(int var1, byte var2) {
      this.aByteArray8981[var1] = var2;
   }

   Class378_Sub2(int var1, int var2, int var3, int var4, int var5, float var6, float var7, float var8) {
      super(var1, var2, var3, var4, var5);
      this.anInt8986 = (int)(var8 * 4096.0F);
      this.anInt8984 = (int)(var7 * 4096.0F);
      this.anInt8987 = this.anInt8988 = (int)(Math.pow(0.5D, (double)(-var6)) * 4096.0D);
   }

   void method6559() {
      this.anInt8980 = 0;
      this.anInt8985 = 0;
   }

   void method6561(int var1, int var2) {
      if(var1 != 0) {
         this.anInt8982 = this.anInt8983 * this.anInt8986 >> 12;
         if(this.anInt8982 < 0) {
            this.anInt8982 = 0;
         } else if(this.anInt8982 > 4096) {
            this.anInt8982 = 4096;
         }

         this.anInt8983 = this.anInt8984 - (var2 < 0?-var2:var2);
         this.anInt8983 = this.anInt8983 * this.anInt8983 >> 12;
         this.anInt8983 = this.anInt8983 * this.anInt8982 >> 12;
         this.anInt8985 += this.anInt8983 * this.anInt8987 >> 12;
         this.anInt8987 = this.anInt8987 * this.anInt8988 >> 12;
      } else {
         this.anInt8983 = this.anInt8984 - (var2 < 0?-var2:var2);
         this.anInt8983 = this.anInt8983 * this.anInt8983 >> 12;
         this.anInt8982 = 4096;
         this.anInt8985 = this.anInt8983;
      }

   }

   void method14390(int var1, byte var2) {
      this.aByteArray8981[var1] = var2;
   }

   void method6567() {
      this.anInt8980 = 0;
      this.anInt8985 = 0;
   }

   void method6568() {
      this.anInt8980 = 0;
      this.anInt8985 = 0;
   }

   void method6560() {
      this.anInt8987 = this.anInt8988;
      this.anInt8985 >>= 4;
      if(this.anInt8985 < 0) {
         this.anInt8985 = 0;
      } else if(this.anInt8985 > 255) {
         this.anInt8985 = 255;
      }

      this.method14389(this.anInt8980++, (byte)this.anInt8985);
      this.anInt8985 = 0;
   }

   void method6570() {
      this.anInt8987 = this.anInt8988;
      this.anInt8985 >>= 4;
      if(this.anInt8985 < 0) {
         this.anInt8985 = 0;
      } else if(this.anInt8985 > 255) {
         this.anInt8985 = 255;
      }

      this.method14389(this.anInt8980++, (byte)this.anInt8985);
      this.anInt8985 = 0;
   }

   void method6565(int var1, int var2) {
      if(var1 != 0) {
         this.anInt8982 = this.anInt8983 * this.anInt8986 >> 12;
         if(this.anInt8982 < 0) {
            this.anInt8982 = 0;
         } else if(this.anInt8982 > 4096) {
            this.anInt8982 = 4096;
         }

         this.anInt8983 = this.anInt8984 - (var2 < 0?-var2:var2);
         this.anInt8983 = this.anInt8983 * this.anInt8983 >> 12;
         this.anInt8983 = this.anInt8983 * this.anInt8982 >> 12;
         this.anInt8985 += this.anInt8983 * this.anInt8987 >> 12;
         this.anInt8987 = this.anInt8987 * this.anInt8988 >> 12;
      } else {
         this.anInt8983 = this.anInt8984 - (var2 < 0?-var2:var2);
         this.anInt8983 = this.anInt8983 * this.anInt8983 >> 12;
         this.anInt8982 = 4096;
         this.anInt8985 = this.anInt8983;
      }

   }

   void method6572(int var1, int var2) {
      if(var1 != 0) {
         this.anInt8982 = this.anInt8983 * this.anInt8986 >> 12;
         if(this.anInt8982 < 0) {
            this.anInt8982 = 0;
         } else if(this.anInt8982 > 4096) {
            this.anInt8982 = 4096;
         }

         this.anInt8983 = this.anInt8984 - (var2 < 0?-var2:var2);
         this.anInt8983 = this.anInt8983 * this.anInt8983 >> 12;
         this.anInt8983 = this.anInt8983 * this.anInt8982 >> 12;
         this.anInt8985 += this.anInt8983 * this.anInt8987 >> 12;
         this.anInt8987 = this.anInt8987 * this.anInt8988 >> 12;
      } else {
         this.anInt8983 = this.anInt8984 - (var2 < 0?-var2:var2);
         this.anInt8983 = this.anInt8983 * this.anInt8983 >> 12;
         this.anInt8982 = 4096;
         this.anInt8985 = this.anInt8983;
      }

   }
}
